"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.build = void 0;
var path = __importStar(require("path"));
var fs = __importStar(require("fs"));
var webpack_1 = __importDefault(require("webpack"));
var getConfig_1 = require("./getConfig");
var webpackConfig_1 = require("./webpackConfig");
var logger_1 = require("./utils/logger");
function build(options) {
    process.env.NODE_ENV = 'production';
    logger_1.Logger.start('Starting bundler in production mode');
    var root = options.root, configFile = options.config;
    var configFilePath = path.resolve(root, configFile);
    if (!fs.existsSync(configFilePath)) {
        logger_1.Logger.error("Config file not found: ".concat(configFilePath));
        process.exit(1);
    }
    var userConfig = (0, getConfig_1.getUserConfig)(configFilePath);
    var config = userConfig.map(function (config) { return (0, webpackConfig_1.webpackConfig)({
        root: root,
        config: config,
    }); });
    (0, webpack_1.default)(config, function (error, stats) {
        if (error) {
            logger_1.Logger.error('Failed to build', error);
            process.exit(1);
        }
        if (stats.hasErrors()) {
            logger_1.Logger.error('Failed to build', stats.toString('errors-only'));
            process.exit(1);
        }
        logger_1.Logger.success('Build completed');
    });
}
exports.build = build;
