"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserConfig = void 0;
var utils_1 = require("./utils");
function getUserConfig(configFilePath) {
    var config;
    if (/\.js$/.test(configFilePath)) {
        config = (0, utils_1.compactDefault)(require(configFilePath));
    }
    else if (/\.ts$/.test(configFilePath)) {
        require('ts-node').register({
            transpileOnly: true,
            compilerOptions: {
                module: 'commonjs',
                target: 'es6',
            },
        });
        config = (0, utils_1.compactDefault)(require(configFilePath));
    }
    return (0, utils_1.makeArray)(config);
}
exports.getUserConfig = getUserConfig;
