#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = __importStar(require("path"));
var commander_1 = require("commander");
var dev_1 = require("./dev");
var build_1 = require("./build");
__exportStar(require("./types"), exports);
var program = new commander_1.Command();
program
    .name('bundler')
    .description('Bundler for JavaScript and TypeScript')
    .usage('[command] [options]');
program
    .command('dev')
    .description('Start the devServer')
    .option('--root <root>', 'Root directory')
    .option('-c, --config <config>', 'Path to the config file', 'bundler.config.js')
    .action(function (options) {
    var cwd = process.cwd();
    var root = path.resolve(cwd, options.root || '');
    (0, dev_1.dev)({
        root: root,
        config: options.config,
    });
});
program
    .command('build')
    .description('Build the project')
    .option('--root <root>', 'Root directory')
    .option('-c, --config <config>', 'Path to the config file', 'bundler.config.js')
    .action(function (options) {
    var cwd = process.cwd();
    var root = path.resolve(cwd, options.root || '');
    (0, build_1.build)({
        root: root,
        config: options.config,
    });
});
program.parse(process.argv);
