"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cssConfig = void 0;
var mini_css_extract_plugin_1 = __importDefault(require("mini-css-extract-plugin"));
var DEFAULT_BROWSERS = [
    '>1%',
    'last 4 versions',
    'Firefox ESR',
    'not ie < 9',
];
function cssConfig(webpackConfig, options) {
    var _a;
    var isDev = process.env.NODE_ENV === 'development';
    var config = options.config;
    var _b = config.cssLoaderOptions, cssLoaderOptions = _b === void 0 ? {} : _b, cssModulesExcludes = config.cssModulesExcludes, lessLoaderOptions = config.lessLoaderOptions, hash = config.hash, _c = config.extraPostCSSPlugins, extraPostCSSPlugins = _c === void 0 ? [] : _c, _d = config.autoprefixer, autoprefixer = _d === void 0 ? {} : _d;
    cssRules({
        test: /\.module\.css$/,
        exclude: cssModulesExcludes,
    }, {
        modules: true,
    });
    cssRules({
        test: /\.module\.less$/,
        exclude: cssModulesExcludes,
    }, {
        modules: true,
        less: true,
    });
    cssRules({
        test: /\.css$/,
        exclude: [/\.module\.(css|less)$/],
    }, {
        modules: false,
    });
    cssRules({
        test: /\.less$/,
        exclude: [/\.module\.(css|less)$/],
    }, {
        modules: false,
        less: true,
    });
    var isHash = hash !== null && hash !== void 0 ? hash : !isDev;
    (_a = webpackConfig.plugins) === null || _a === void 0 ? void 0 : _a.push(new mini_css_extract_plugin_1.default({
        filename: isHash ? '[name].[contenthash].css' : '[name].css',
        chunkFilename: isHash ? '[id].[contenthash].css' : '[id].css',
    }));
    function cssRules(rule, options) {
        var _a;
        rule.use = (rule.use || []);
        rule.use.push({
            loader: mini_css_extract_plugin_1.default.loader,
        });
        var cssOptions = __assign({ importLoaders: 1 }, cssLoaderOptions);
        rule.use.push({
            loader: require.resolve('css-loader'),
            options: __assign(__assign({}, cssOptions), { modules: options === null || options === void 0 ? void 0 : options.modules }),
        });
        rule.use.push({
            loader: require.resolve('postcss-loader'),
            options: {
                postcssOptions: {
                    ident: 'postcss',
                    plugins: __spreadArray([
                        [require.resolve('autoprefixer'), __assign({ overrideBrowserslist: DEFAULT_BROWSERS, flexbox: 'no-2009' }, autoprefixer)]
                    ], extraPostCSSPlugins, true)
                }
            },
        });
        if (options === null || options === void 0 ? void 0 : options.less) {
            rule.use.push({
                loader: require.resolve('less-loader'),
                options: {
                    lessOptions: lessLoaderOptions
                }
            });
        }
        (_a = webpackConfig.module) === null || _a === void 0 ? void 0 : _a.rules.push(rule);
    }
}
exports.cssConfig = cssConfig;
